set_1 = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10}
set_2 = {3, 4, 5, 6, 7, 8, 9}
set_3 = {0, 1, 1, 2, 3, 5, 8, 13, 21}
set_4 = {0, 1, 1, 2, 3, 5, 8, 13, 21, 34}
set_5 = {5, 6, 7, 8, 9}
set_6 = {6, 7, 8, 9, 10}


print(dir(set_1))

# Удаляет элементы другого сета из данного сета, не создает новый объект.
set_1.difference_update(set_2)
print(set_1)

# Удаляет указанный элемент из сета. Если его там нет, не делает ничего; не создает новый объект.
set_2.discard(7)
print(set_2)

# Оставляет в сете только элементы пересечения с другим сетом. Не создает новый объект.
set_2.intersection_update(set_3)
print(set_2)
# Соответственно, если пересечение отсутствует, сет становится пустым.
# set_2.intersection_update(set_1)
# print(set_2)

# Возвращает тру, если у данного и другого указанного сета нет ни одного общего элемента. Создает новый объект.
set_1.isdisjoint(set_3)
print(set_1.isdisjoint(set_3))
print(id(set_1))
print(id(set_1.isdisjoint(set_3)))

# Возвращает тру, если все элементы данного сета принадлежат другому указанному сету. Создает новый объект.
set_1.issubset(set_3)
print(set_1.issubset(set_3))

# Возвращает тру, если данный сет содержит все элементы другого указанного сета. Создает новый объект
set_1.issuperset(set_2)
print(set_1.issuperset(set_2))
print(set_4.issuperset(set_3))

# Создает новый сет, состоящий из элементов, принадлежащих одному и только одному из двух данных сетов.

set_3.symmetric_difference(set_4)
print(set_3.symmetric_difference(set_4))

# Отличие от .difference - последний берёт только элементы, принадлежащие данному сету, а не другому указанному,
# но не наоборот. Поэтому .difference в примере ниже выдаст только 5, а .symmetric_difference - 5 и 10.
print(set_5, set_6)
print(set_5.difference(set_6))
print(set_5.symmetric_difference(set_6))

# Апдейтит сет так, что тот состоит из элементов, принадлежащих либо только ему, либо только другому указанному.
# Не создаёт новый объект.
set_5.symmetric_difference_update(set_6)
print(set_5)

# Объединяет два сета в новый, состоящий из всех элементов в каком-либо из данных сетов.
# Создает новый объект.
set_1.union(set_3)
print(set_1.union(set_3))

